SystemOrganization addCategory: #'IRDA2013-sorting2-Challenges'!

Object subclass: #S2AbstractChallenge
	instanceVariableNames: 'sorter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Challenges'!

!S2AbstractChallenge class methodsFor: 'accessing' stamp: 'AT 5/27/2013 13:57:11.695'!
challengeDescription
	^'MyDescription'! !

!S2AbstractChallenge class methodsFor: 'accessing' stamp: 'AT 5/27/2013 13:57:28.472'!
challengeName
	^'MyName'! !

!S2AbstractChallenge class methodsFor: 'accessing' stamp: 'AT 5/27/2013 12:41:04.902'!
challengeNumber
	^nil! !

!S2AbstractChallenge class methodsFor: 'initializing' stamp: 'AT 5/27/2013 12:43:15.562'!
newWithNumber: nr
	|class|
	class := self.
	subclasses do: [:each |
		each challengeNumber = nr
		ifTrue: [class := each].  
	].
	^ (class new)! !

!S2AbstractChallenge methodsFor: 'accessing' stamp: 'JB 7/8/2013 17:44:11.845'!
controlsEnabled

	^ true.! !

!S2AbstractChallenge methodsFor: 'accessing' stamp: 'AT 5/27/2013 13:58:39.474'!
description
	^self class challengeName.! !

!S2AbstractChallenge methodsFor: 'accessing' stamp: 'JB 7/8/2013 17:49:51.708'!
editableMethodForSorter: aSorter
	"The Method that should be displayed for this challenge"
	^ nil! !

!S2AbstractChallenge methodsFor: 'accessing' stamp: 'AT 5/27/2013 13:58:01.242'!
name
	^ self class challengeName.! !

!S2AbstractChallenge methodsFor: 'accessing' stamp: 'JB 7/7/2013 23:28:50.398'!
number
	^self class challengeNumber! !

!S2AbstractChallenge methodsFor: 'signalling' stamp: 'AT 5/27/2013 13:47:07.364'!
onWin
	self halt.
	self emit.! !

!S2AbstractChallenge methodsFor: 'starting' stamp: 'AT 5/27/2013 12:59:16.155'!
setup: morph! !

!S2AbstractChallenge methodsFor: 'signalling' stamp: 'AT 5/27/2013 13:47:48.863'!
sorted
	self win! !

!S2AbstractChallenge methodsFor: 'accessing' stamp: 'JB 6/10/2013 15:48:52.523'!
sorter
	^self subclassResponsibility.! !

!S2AbstractChallenge methodsFor: 'starting' stamp: 'AT 5/27/2013 12:27:58.434'!
start
	'instructions to set up the challenge UI'! !

!S2AbstractChallenge methodsFor: 'signalling' stamp: 'AT 5/27/2013 13:48:00.519'!
win
	self emit.! !

S2AbstractChallenge subclass: #S2AutomaticBubblesortChallenge
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Challenges'!

!S2AutomaticBubblesortChallenge class methodsFor: 'as yet unclassified' stamp: 'JB 7/8/2013 17:28:45.368'!
challengeDescription
	^'Watch how bubblesort sorts the list below.'! !

!S2AutomaticBubblesortChallenge class methodsFor: 'as yet unclassified' stamp: 'JB 7/8/2013 17:25:23.985'!
challengeName
	^'Automatic Bubblesort'! !

!S2AutomaticBubblesortChallenge methodsFor: 'as yet unclassified' stamp: 'JB 7/8/2013 17:51:01.732'!
editableMethodForSorter: aSorter
	"The Method that should be displayed for this challenge"
	^ aSorter listPartFinder class methodDict at: #findSublist.! !

!S2AutomaticBubblesortChallenge methodsFor: 'as yet unclassified' stamp: 'JB 6/10/2013 16:20:43.805'!
sorter
	^ S2BubbleSorter! !

S2AbstractChallenge subclass: #S2AutomaticMergesortChallenge
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Challenges'!

!S2AutomaticMergesortChallenge methodsFor: 'as yet unclassified' stamp: 'db 7/8/2013 16:31:30.608'!
sorter
	^ S2MergeSorter! !

S2AbstractChallenge subclass: #S2AutomaticQuickSortChallenge
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Challenges'!

!S2AutomaticQuickSortChallenge class methodsFor: 'as yet unclassified' stamp: 'JB 7/8/2013 17:28:48.365'!
challengeDescription
	^'Watch how Quicksort sorts the list below.'! !

!S2AutomaticQuickSortChallenge class methodsFor: 'as yet unclassified' stamp: 'JB 7/8/2013 17:25:34.518'!
challengeName
	^'Automatic Quicksort'! !

!S2AutomaticQuickSortChallenge methodsFor: 'as yet unclassified' stamp: 'AT 7/4/2013 14:44:35.332'!
sorter
	^S2QuickSorter! !

S2AbstractChallenge subclass: #S2Challenge1
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Challenges'!

!S2Challenge1 class methodsFor: 'accessing' stamp: 'AT 5/27/2013 13:56:36.502'!
challengeDescription
	'Do something'! !

!S2Challenge1 class methodsFor: 'accessing' stamp: 'AT 5/27/2013 13:56:21.99'!
challengeName
	^'Challenge 1: Sort the List'! !

!S2Challenge1 class methodsFor: 'accessing' stamp: 'AT 5/27/2013 12:41:26.714'!
challengeNumber
 ^1! !

!S2Challenge1 methodsFor: 'starting' stamp: 'db 6/17/2013 17:46:35.912'!
setup: morph
| listModel listMorph sorter b |
	
	listModel := S2ListModel new.
	listModel items: (1 to: 7) asOrderedCollection shuffled.
	
	listMorph := S2ListMorphOld new.
	"observer pattern"
	listModel addDependent: listMorph.
	listModel changed.
		
	sorter :=	S2BubbleSorter new.
	sorter model: listModel.
	self connect: sorter signal: #onSorted toSelector: #sorted. 
	
	morph addMorph: listMorph.
	listMorph position: morph position + (0@25).

	b := SimpleButtonMorph new.
	b color: Color green;
	label: 'Next Sort Step';
	target: sorter;
	actionSelector: #nextStep;
	setBalloonText: 'click to sort'.
	morph addMorph: b.
	b position: morph position! !

!S2Challenge1 methodsFor: 'starting' stamp: 'db 6/17/2013 17:46:39.964'!
start
| listModel listMorph sorter |
	
	listModel := S2ListModel new.
	listModel items: (1 to: 7) asOrderedCollection shuffled.
	
	listMorph := S2ListMorphOld new.
	"observer pattern"
	listModel addDependent: listMorph.
	listModel changed.
		
	sorter :=	S2BubbleSorter new.
	sorter model: listModel.
	
	"self showAlert: listMorph.

	b := SimpleButtonMorph new.
	b color: Color green;
	label: 'Next Sort Step';
	target: sorter;
	actionSelector: #nextStep;
	setBalloonText: 'click to sort'.
	self addMorph: b."! !

S2AbstractChallenge subclass: #S2FreeSortChallenge
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Challenges'!

!S2FreeSortChallenge class methodsFor: 'as yet unclassified' stamp: 'JB 7/8/2013 17:25:00.419'!
challengeDescription
	^'MyDescription'! !

!S2FreeSortChallenge class methodsFor: 'as yet unclassified' stamp: 'JB 7/8/2013 17:25:42.467'!
challengeName
	^'Free Sorting'! !

!S2FreeSortChallenge methodsFor: 'as yet unclassified' stamp: 'JB 7/8/2013 17:44:03.816'!
controlsEnabled

	^ false.! !

!S2FreeSortChallenge methodsFor: 'as yet unclassified' stamp: 'JB 7/7/2013 23:22:57.125'!
sorter
	^ S2BubbleSorter! !

S2AbstractChallenge subclass: #S2ManualBubblesortChallenge
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'IRDA2013-sorting2-Challenges'!

!S2ManualBubblesortChallenge class methodsFor: 'as yet unclassified' stamp: 'JB 7/8/2013 17:28:06.824'!
challengeDescription
	^'Sort the list below using the Bubblesort algorithm.'! !

!S2ManualBubblesortChallenge class methodsFor: 'as yet unclassified' stamp: 'JB 7/8/2013 17:25:51.36'!
challengeName
	^'Manual Bubblesort'! !

!S2ManualBubblesortChallenge methodsFor: 'as yet unclassified' stamp: 'JB 7/8/2013 17:43:59.004'!
controlsEnabled

	^ false.! !

!S2ManualBubblesortChallenge methodsFor: 'as yet unclassified' stamp: 'JB 7/7/2013 23:23:17.811'!
sorter
	^ S2BubbleSorter ! !
